/***************************************************************************
 *	cd_data.h: ãģ̥եΥ饤֥ѥإåե
 *			
 *			Version 0.01		1994/04/19 (Tues.) --
 *			Version 1.0			1997/10/12 
 *			
 *			Programed by Nobuyuki Maruichi
 ***************************************************************************/

#ifndef	_CD_DATA_H
#define	_CD_DATA_H

#include <fcntl.h>
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */

/***************************************************************************
 *	TrackData ãľΥȥå
 *	¤ΤΥС
 *		TrackTime  С:	ȥåջ
 *		TrackTitle С:	ʤΥȥ
 *		
 *		TrackData Υǡ
 *		
 *		minuteġʬ
 *		
 *		ȥåջ֨secondġá
 *		
 *		frame ĥե졼ਭ
 *		
 *		
 *		ʤΥȥ롡char  ʤΥȥ
 *		43 Х '\0'üʸ
 *		
 *		
 ***************************************************************************/
typedef struct _TrackDataForm {
	struct cd_time trackTime;	/* ȥåջ */
	char trackTitle[43];		/* ʤΥȥ */
} TrackData;

/***************************************************************************
 *	CddaDataForm ãľΥǥʬ
 *	¤ΤΥС
 *		CdTitle С:		ãĤΥȥ
 *		Artist С:		ƥ
 *		Label С:			졼٥
 *		ReleaseDate С:	ȯ
 *		Tracks С:		ȥå
 *		TiffFile С:		ե̾
 *		LyricsFile С:	λե̾
 *		track_ptr С:		ȥåؤݥ
 *		next_ptr С:		󥯡ݥ
 *	
 *		ǡ¤
 *		CddaDataForm TrackData Υǡ
 *		
 *		ãĤΥȥ먭ȥåջ֨
 *		
 *		 ƥ ʤΥȥ롡
 *		
 *		 졼٥ ȥåջ֨
 *		
 *		ȯʤΥȥ롡
 *		
 *		ȥå
 *		
 *		ե̾
 *		
 *		λե̾ȥåջ֨
 *		ǽ
 *		 ȥå ʤΥȥ롡
 *		
 *		󥯥ݥ󥿨
 *		ءãĤΥȥ먭
 *		
 *		 ƥ 
 *		
 *		 졼٥ 
 *		ʤ顡
 *		ȯ
 *		NULLݥ󥿡
 *	
 ***************************************************************************/
typedef struct _CddaDataForm {
	char cdTitle[43];			/* ãĤΥȥ */
	char artist[43];			/* ƥ */
	char label[43];				/* 졼٥ */
	char releaseDate[11];		/* ȯ */
	int  tracks;				/* ȥå */
	char tiffFile[9];			/* ե̾ */
	char lyricsFile[7];			/* λե̾ */
	TrackData *track_ptr;			/* ȥåؤݥ */
	struct _CddaDataForm *next_ptr;		/* 󥯡ݥ */
} CddaDataForm;

/***************
 *  Prototype
 ***************/
TrackData *TrackDataAlloc(int tracks);
CddaDataForm *DiscDataAlloc(int tracks);
int get_string(char *string_ptr, const char *buffer_ptr, int max_length, int flag);
char *getTrack(TrackData *track_ptr, FILE *stream, int flag);
int getTrackData(TrackData *track_ptr, int tracks, FILE *stream, int flag);
CddaDataForm *MakeDiscData(FILE *stream, int flag);
CddaDataForm *fmakeDiscsData(FILE *stream, int flag);
CddaDataForm *MakeDiscsData(const char *filename, int flag);
long int TrackFrames(int track_no, const struct cd_toc *toc);
int cmp_Toc_DiscData(const CddaDataForm *disc_data_ptr,
							const struct cd_toc *toc_ptr);
void dispDiscInfomation(CddaDataForm *disc_data, struct cd_toc *toc);
CddaDataForm *SearchDiscData(int disc_num,
		CddaDataForm *disc_data_ptr, const struct cd_toc *toc_ptr);
void fputDiscsData(const CddaDataForm *disc_info, FILE *stream);
void SaveDiscsData(const char *filename, const CddaDataForm *disc_info);
CddaDataForm *MakeNewDiscData(const struct cd_toc *toc, int flag);
CddaDataForm *DiscDataMerge(CddaDataForm *prevDiscData, 
									CddaDataForm *connectDiscData);
int isCdlCodeset(const CddaDataForm *cdl_ptr);
#endif	/*_CD_DATA_H*/
