/***************************************************************************
 *	cd_program.c - ץൡǽϢ
 *	
 *			1994/ 5/ 9 (Man.) -- 
 *
 *					Programmed by Nobuyuki Maruichi
 *	Note.
 *			
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/*****************************************
 * Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#ifdef	X11R5
# include <X11/Xaw/Xawi18n.h>
# include <X11/Xaw/XawIm.h>
#endif	/*X11R5*/

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "mwxcd.h"
#include "cdda_ext.h"

/*
 *	Хѿ
 */
Widget pcmenushell, p2shell, cmenupressme;
Widget cmenupane[10];
Widget programList;
Widget programFlashing;
Widget programUnmark;

Widget pDiscShell;
Widget popdownDisc, DiscBlock, DiscTitle, DiscArtist;
Widget DiscDataOuter, DiscDataInner, DiscLabelLogo;
Widget DiscData1, DiscDate, DiscLabel, DiscData2, DiscTiff, DiscWords;
Widget DiscView, DiscTrackList;
char DiscDataFilename[256];

String ProgramStrings[100];
extern Cd_Order *ProgramList_ptr;
extern AppData app_data;

/***************************************************************************
 *	PlaceCommandMenu: ޥɡ˥塼ΰ֤׻
 *	
 *		void PlaceCommandMenu(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PlaceCommandMenu(Widget w, XtPointer client_data, XtPointer call_data)
{
	Position x, y;
	Dimension height;

	/*
	 *	ޥɡ˥塼ƤӽФܥκɸ
	 *	롼ȡɥθǵ
	 */
	XtTranslateCoords(cmenupressme, /* Widget */
			(Position) 0, 			/* x */
			(Position) 0, 			/* y */
			&x, &y); 				/* coords on root window */

	/* ޥɡ˥塼ƤӽФܥι⤵ */
	XtVaGetValues(cmenupressme, 
			XtNheight, &height,
			NULL);

	/*
	 *	ޥɡ˥塼ΰ֤ꤹ롣
	 *	ʤޤԲĻξ֡
	 */
	XtVaSetValues(pcmenushell, 
			XtNx, x - 1,   /* -1 accounts for border width */
			XtNy, y + height + 2,
			NULL);
}

/***************************************************************************
 *	CmenuPaneChosen: Command ˥塼ܤΥХåؿ
 *	
 *		void CmenuPaneChosen(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void CmenuPaneChosen(Widget w, XtPointer client_data, XtPointer call_data)
{ 
	XtPopdown(pcmenushell);
}

/***************************************************************************
 *	PopupDialog: ץࡦꥹȤΥݥåץå׺ɸȤ
 *	
 *		void PopupDialog(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;		topLevel ˥㥹Ȥ
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupDialog(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget topLevel = (Widget) client_data;
	Position x, y;
	Dimension width, height;

	/*
	 *	topLevel widget 礭롣
	 */
	XtVaGetValues(topLevel, 
			XtNwidth, &width,
			XtNheight, &height,
			NULL);
	
	/*
	 *	topLevel widget Υ롼ȡɥΰ֤
	 */
	XtTranslateCoords(topLevel, 	/* Widget */
			(Position) width/2, 	/* x */
			(Position) height/2,	/* y */
			&x, &y); 				/* coords on root window */

	/*
	 *	ץࡦꥹȡݥåץåפΰ֤ꤹ롣
	 *	ʤޤԲĻξ֡
	 */
	XtVaSetValues(p2shell, 
			XtNx, x,
			XtNy, y,
			NULL);
}

/***************************************************************************
 *	ProgramListPopdown: ץࡦꥹȤΥɥݥåץ󤹤
 *	
 *		void ProgramListPopdown(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ץࡦꥹȤΥɥݥåץ󤷤ޤ
 ***************************************************************************/
/*ARGSUSED*/
void ProgramListPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtPopdown(p2shell);

	XtSetSensitive(cmenupane[0], TRUE);
}

/***************************************************************************
 *	ProgramMark: ץࡦꥹ
 *	
 *		void ProgramMark(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void ProgramMark(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtVaSetValues(programUnmark, XtNstate, True, NULL);
}

/***************************************************************************
 *	UnsetUnmark: ץࡦꥹ
 *	
 *		void UnsetUnmark(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void UnsetUnmark(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget unmark = (Widget) client_data;

	XtVaSetValues(unmark, XtNstate, False, NULL);
}

/***************************************************************************
 *	ProgramUnmark: ץࡦꥹ
 *	
 *		void ProgramUnmark(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void ProgramUnmark(Widget w, XtPointer client_data, XtPointer call_data)
{
	XawListUnhighlight(programList);
}

#ifdef	DEBUG
/***************************************************************************
 *	ProgramTest: 
 *	
 *		void ProgramTest(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void dispProgramTestPrev2(Cd_Order *traceOrder, int counter)
{
	if(traceOrder != NULL) {
		dispProgramTestPrev2(traceOrder->prev_order_ptr, counter - 1);
		printf("##%03d:[#%d(%d'%02d)-#%d(%d'%02d)]\n", 
				counter,
				traceOrder->start_track, 
				traceOrder->play_info.start.minute, 
				traceOrder->play_info.start.second, 
				traceOrder->end_track, 
				traceOrder->play_info.end.minute, 
				traceOrder->play_info.end.second);
	}
}

/***************************************************************************
 *	ProgramTest: 
 *	
 *		void ProgramTest(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void dispProgramTestPrev(Cd_Order *traceStartOrder)
{
	int counter;
	Cd_Order *traceOrder;
	
	for(traceOrder = traceStartOrder, counter = 0;traceOrder != NULL;
				traceOrder = traceOrder->prev_order_ptr, --counter) {
		printf("##%03d:[#%d(%d'%02d)-#%d(%d'%02d)]\n", 
				counter,
				traceOrder->start_track, 
				traceOrder->play_info.start.minute, 
				traceOrder->play_info.start.second, 
				traceOrder->end_track, 
				traceOrder->play_info.end.minute, 
				traceOrder->play_info.end.second);
	}
}

/***************************************************************************
 *	ProgramTest: 
 *	
 *		void ProgramTest(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void dispProgramTestNext(Cd_Order *traceStartOrder)
{
	int counter;
	Cd_Order *traceOrder;
	
	for(traceOrder = traceStartOrder, counter = 0;traceOrder != NULL;
				traceOrder = traceOrder->next_order_ptr, ++counter) {
		printf("##%03d:[#%d(%d'%02d)-#%d(%d'%02d)]\n", 
				counter,
				traceOrder->start_track, 
				traceOrder->play_info.start.minute, 
				traceOrder->play_info.start.second, 
				traceOrder->end_track, 
				traceOrder->play_info.end.minute, 
				traceOrder->play_info.end.second);
	}
}

/***************************************************************************
 *	ProgramTest: 
 *	
 *		void ProgramTest(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void ProgramTest(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern Cd_Order *CdOrder_ptr;
	extern Cd_Order *ProgramConnect;
	
	printf("** List from ProgramConnect\n");
	if(ProgramConnect != NULL) {
		dispProgramTestPrev2(ProgramConnect->prev_order_ptr, -1);
	}
	/*dispProgramTestPrev(ProgramConnect);*/
	dispProgramTestNext(ProgramConnect);
	printf("** List from CdOrder_ptr\n");
	if(CdOrder_ptr != NULL) {
		dispProgramTestPrev2(CdOrder_ptr->prev_order_ptr, -1);
	}
	dispProgramTestNext(CdOrder_ptr);
}
#endif	/*DEBUG*/

/***************************************************************************
 *	FlashingProgram: Υץΰ֥եå夵
 *	
 *		void FlashingProgram(void);
 *	
 *		
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void FlashingProgram(void)
{
	int programNow;
	Boolean flashingMode;
	static Boolean flashingFlag = False;
	extern Cd_Order *CdOrder_ptr;
	extern int OrderMode;
	
	if(OrderMode == ProgramOrder) {
		XtVaGetValues(programFlashing, XtNstate, &flashingMode, NULL);
		if(flashingMode == True)
			flashingMode = XtIsSensitive(programFlashing);
		if(flashingMode == True /*&& DiscTrackList->core.visible == True*/) {
			programNow = ProgramCount(CdOrder_ptr);
			/*printf("programNow = %d.\n", programNow);*/
			flashingFlag = ((flashingFlag == False)?(True):(False));
			if(flashingFlag == True && programNow > 0)
				XawListHighlight(programList, programNow - 1);
			else
				XawListUnhighlight(programList);
		}
	}
}

/***************************************************************************
 *	cmenu_init: ޥɡ˥塼ץࡦꥹȤνԤ
 *	
 *		void cmenu_init(XtAppContext app_context, 
 *				Widget topLevel, Widget cd_panel, Widget box);
 *	
 *		XtAppContext app_context;
 *		Widget topLevel;
 *		Widget cd_panel;
 *		Widget box;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void cmenu_init(XtAppContext app_context, 
							Widget topLevel, Widget cd_panel, Widget box)
{
	Widget cmenubox, cmenuLabel;
	Widget dialog, buttons, programView;
	Widget programListPopdown, clearData;
	Widget programRandom, programJump, programDelete;
	int i;
	char buf[50];
	extern int TrackNumbers[];
	void memory_init(XtAppContext app_context, Widget popupButton, Widget parent);
	void Enviroment_init(Widget topLevel, Widget cd_panel, Widget popupButton);

	/***************************************
	 *	ޥɡ˥塼Ϣå
	 ***************************************/
	cmenupressme = XtCreateManagedWidget(
		"cmenupressme",  			/* widget name   */
		commandWidgetClass, 		/* widget class */
		box,    					/* parent widget*/
		NULL,   					/* argument list*/
		0   						/* arglist size */
		);

	pcmenushell = XtCreatePopupShell(
		"pcmenushell",
		transientShellWidgetClass,
		cmenupressme,
		NULL,
		0
		);

	cmenubox = XtCreateManagedWidget(
		"cmenubox", 				/* widget name   */
		boxWidgetClass, 			/* widget class */
		pcmenushell, 				/* parent widget*/
		NULL, 						/* argument list*/
		0 							/* arglist size */
		);

	cmenuLabel = XtCreateManagedWidget(
		"cmenuLabel",				/* widget name */
		labelWidgetClass, 			/* widget class */
		cmenubox, 					/* parent widget*/
		NULL, 						/* argument list*/
		0							/* arglist size */
		);

	for (i = 0; i < 8; i++) {
		sprintf(buf, "cmenupane%d", i);
			cmenupane[i] = XtCreateManagedWidget(buf,   /* widget name   */
			        commandWidgetClass, cmenubox, NULL, 0);

		XtAddCallback(cmenupane[i], XtNcallback, 
							CmenuPaneChosen, &TrackNumbers[i]);
	}

	DiscData_init(topLevel, cd_panel, cmenupane[1]);
	memory_init(app_context, cmenupane[2], topLevel);
	volume_init(topLevel, cmenupane[3]);
	WordsInit(topLevel, cd_panel, cmenupane[4]);
	/***************************************
	 *	ץࡦꥹȴϢå
	 ***************************************/
	p2shell = XtCreatePopupShell(
			"p2shell",
			topLevelShellWidgetClass,
			topLevel,
			NULL,
			0
			);

	dialog = XtCreateManagedWidget(
			"dialog", 					/* widget name   */
			panedWidgetClass, 			/* widget class */
			/*formWidgetClass,*/		/* widget class */
			/*dialogWidgetClass,*/		/* widget class */
			p2shell, 					/* parent widget*/
			NULL, 						/* argument list*/
			0 							/* arglist size */
			);

	buttons = XtCreateManagedWidget(
			"buttons", 					/* widget name   */
			panedWidgetClass, 			/* widget class */
			/*formWidgetClass,*/		/* widget class */
			/*dialogWidgetClass,*/		/* widget class */
			dialog, 					/* parent widget*/
			NULL, 						/* argument list*/
			0 							/* arglist size */
			);

	programListPopdown = XtCreateManagedWidget(
			"programListPopdown", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			buttons, 					/* parent widget*/
			NULL, 						/* argument list*/
			0 							/* arglist size */
			);

	clearData = XtCreateManagedWidget(
			"clearData", 			/* widget name */
			commandWidgetClass, 	/* widget class */
			buttons, 				/* parent widget */
			NULL, 					/* argument list */
			0						/* arglist size */
			);

	programJump = XtCreateManagedWidget(
			"programJump", 			/* widget name */
			commandWidgetClass, 	/* widget class */
			buttons, 				/* parent widget */
			NULL, 					/* argument list */
			0						/* arglist size */
			);

	programDelete  = XtCreateManagedWidget(
			"programDelete", 		/* widget name */
			commandWidgetClass, 	/* widget class */
			buttons, 				/* parent widget */
			NULL, 					/* argument list */
			0						/* arglist size */
			);
	
	programRandom = XtVaCreateManagedWidget(
			"programRandom", 		/* widget name */
			commandWidgetClass, 	/* widget class */
			buttons, 				/* parent widget */
			NULL);

	programFlashing = XtVaCreateManagedWidget(
			"programFlashing", 		/* widget name */
			toggleWidgetClass, 		/* widget class */
			buttons, 				/* parent widget */
			NULL); 					/* argument list */
	
	programUnmark = XtVaCreateManagedWidget(
			"programUnmark", 		/* widget name */
			toggleWidgetClass, 		/* widget class */
			buttons, 				/* parent widget */
			NULL); 					/* argument list */
	
#ifdef	DEBUG
	XtSetSensitive(programJump, False);
	XtSetSensitive(programDelete, False);
#endif	/*DEBUG*/
	
	programView = XtVaCreateManagedWidget(
			"programView", 			/* widget name   */
			viewportWidgetClass, 	/* widget class */
			dialog, 				/* parent widget */
			NULL 					/* argument list */
			);
	
	programList = XtVaCreateManagedWidget(
			"programList", 			/* widget name   */
			listWidgetClass, 	/* widget class */
			programView, 			/* parent widget */
			NULL 					/* argument list */
			);

	Enviroment_init(topLevel, cd_panel, cmenupane[5]);

	XtAddCallback(pcmenushell, XtNpopupCallback, PlaceCommandMenu, NULL);
	XtAddCallback(programListPopdown, XtNcallback, ProgramListPopdown, dialog);
	XtAddCallback(programListPopdown, XtNcallback, UnsetUnmark, programUnmark);
	XtAddCallback(cmenupane[0], XtNcallback, PopupDialog, cd_panel);
	XtAddCallback(cmenupane[0], XtNcallback, XtCallbackNone, p2shell);
	XtAddCallback(cmenupane[6], XtNcallback, VersionPopup, 0);
	XtAddCallback(cmenupane[7], XtNcallback, Quit, 0);
	XtAddCallback(clearData, XtNcallback, ProgramClear, 0);
	XtAddCallback(clearData, XtNcallback, ProgramUnmark, 0);
	XtAddCallback(clearData, XtNcallback, UnsetUnmark, programUnmark);
	XtAddCallback(programJump, XtNcallback, ProgramUnmark, 0);
	XtAddCallback(programJump, XtNcallback, UnsetUnmark, programUnmark);
	/*XtAddCallback(programDelete, XtNcallback, ProgramUnmark, 0);*/
	/*XtAddCallback(programDelete, XtNcallback, UnsetUnmark, programUnmark);*/
	XtAddCallback(programUnmark, XtNcallback, ProgramUnmark, 0);
	XtAddCallback(programList, XtNcallback, ProgramMark, 0);
	XtAddCallback(programList, XtNcallback, ProgramPoint, 0);
/*	XtAddCallback(programFlashing, XtNcallback, ProgramTest, 0);*/
	XtAddCallback(programJump, XtNcallback, ProgramJump, 0);
	XtAddCallback(programDelete, XtNcallback, ProgramDelete, 0);
}

