/***************************************************************************
 *	cdl_gui.c - ǥϢεǽ
 *	
 *			1994/ 8/ 2 (Man.) -- 
 *
 *					Programmed by Nobuyuki Maruichi
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>
#include <limits.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

/**************************************************************
 * Atena Widgetݲ Atena Widget Υ󥯥롼ɡե
 **************************************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/MultiSrc.h>
#include <X11/Xaw/MultiSink.h>
#ifdef	X11R5
# include <X11/Xaw/XawIm.h>
# include <X11/Xaw/Xawi18n.h>
#endif	/*X11R5*/

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "mwxcd.h"
#include "cdda_ext.h"
#include "cd_data.h"
#include "cd_word.h"
#include "file_sel.h"
#include "luty.h"

/*****************************************
 *	Хѿ
 *
 *
 *****************************************/
Widget pEnterShell;
Widget pDiscShell;
Widget trackShell, trackDataDialog;
Widget discDataFlashing;
Widget DiscTiffSelect, DiscWordsSelect;
Widget popdownDisc, DiscBlock, DiscTitle, DiscArtist;
Widget DiscDataOuter, DiscDataInner, DiscLabelLogo;
Widget enterDiscData;
Widget DiscData1, DiscDate, DiscLabel, DiscData2, DiscTiff, DiscWords;
Widget DiscView, DiscTrackList;
Widget filenameDiscData;
extern Widget cmenupane[10];
char DiscDataFilename[256];
static char *TrackString[100];
static CddaDataForm DummyDiscData;
static Widget discDataDialog;
static Boolean popupShellFlag = False;
static const char *DiscDataError = NULL;

extern AppData app_data;
extern Pixmap diskMark;
extern Pixmap diskDisable;

int cdlFileEncode = EOF;

/***************************************************************************
 *	ãģ̥եϢΥХѿ
 *		CurrentDisc_ptr:	ߤΥǥΣãģ̥ǡؤݥ
 *		CurrentDiscFlag:	ߤΥǥãģ̥ǡȤƥ󥯺Ѥ
 *			 TRUE :	󥯺ѡʣãģ̥ե˵ϿѤϿѡ
 *			 FALSE:	󥯤Ƥʤʿãġ
 ***************************************************************************/
extern CddaDataForm *CurrentDisc_ptr;
extern int CurrentDiscFlag;	
/***************************************************************************
 *	DiscDataEnter 
 *		option_func:	ϿʸΥХåؿ
 *		get_cdl_string:	CDL ǡϿѤʸؿ
 *		limit:			CDL ǡϿѤʸΥХåեĹ
 *		label:			̤
 *		string_offset:	CDL ǡʸΰ
 *		track:			ȥå
 *		string_ptr:		CDL ǡʸؤݥ󥿡ʥݥåץåס
 *		popdownInfo:	ݥåץ
 *			.popdownShell:	ݥåץåסΥå
 *			.popupWidget:	ݥåץåפΥȥꥬˤʤäå
 *			.client_data:	å
 ***************************************************************************/
typedef struct _discDataEnter {
	void (*option_func)(struct _discDataEnter *discEnter);
	String (*get_cdl_string)(struct _discDataEnter *discEnter);
	int limit;
	String label;
	int string_offset;
	int track;
	String string_ptr;
	PopdownInfo popdownInfo;
} DiscDataEnter;

static DiscDataEnter *DialogDiscEnter_ptr;

void enterModeControl(Widget w, XtPointer client_data, XtPointer call_data);

/***************************************************************************
 *  GetDiscDataTrackPosition: DiscDataEnter顢ǡǼ
 *  
 *      String GetDiscDataTrackPosition(DiscDataEnter *discEnter);
 *  
 *      DiscDataEnter *discEnter;
 *  
 *		
 *		get_cdl_string:	CDL ǡϿѤʸޤ
 *      
 ***************************************************************************/
String GetDiscDataTrackPosition(DiscDataEnter *discEnter)
{
	extern CddaDataForm *CurrentDisc_ptr;
	
	return((CurrentDisc_ptr->track_ptr + discEnter->track)->trackTitle);
}

/***************************************************************************
 *  GetCddaDataPosition: DiscDataEnter顢ǡǼ
 *  
 *      String GetCddaDataPosition(DiscDataEnter *discEnter);
 *  
 *      DiscDataEnter *discEnter;
 *  
 *      
 ***************************************************************************/
String GetCddaDataPosition(DiscDataEnter *discEnter)
{
	extern CddaDataForm *CurrentDisc_ptr;
	
	return(((char*)CurrentDisc_ptr) + discEnter->string_offset);
}

/***************************************************************************
 *	SetLabelString: ǥǡκɽ
 *	
 *		void SetLabelString(DiscDataEnter *discEnter);
 *	
 *		DiscDataEnter *discEnter;	
 *	
 *		
 ***************************************************************************/
void SetLabelString(DiscDataEnter *discEnter)
{
	char *tmpBuffer;

	tmpBuffer = cdljc(((String)CurrentDisc_ptr) + discEnter->string_offset);
	XtVaSetValues(discEnter->popdownInfo.popupWidget, 
									XtNlabel, tmpBuffer, NULL);
}

/***************************************************************************
 *	RenewalDiscList: ǥǡκɽ
 *	
 *		void RenewalDiscList(DiscDataEnter *discEnter);
 *	
 *		DiscDataEnter *discEnter;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void RenewalDiscList(DiscDataEnter *discEnter)
{
	int track;
	char *tmpBuffer;
	extern int CdTrack;
	extern struct cd_toc CddaToc;
	extern Widget wordsTitle;
	extern int CurrentWordsTrack;

	track = (CurrentWordsTrack - (CurrentWordsTrack > 0)); 
	track_set(CdTrack);
	if(CurrentDisc_ptr != NULL) {
		MakeDiscInfomation(CurrentDisc_ptr, &CddaToc);
		MakeProgramOrderList();
		make_cd_menu(&CddaToc);
		tmpBuffer = cdljc((CurrentDisc_ptr->track_ptr + track)->trackTitle);
		XtVaSetValues(wordsTitle, XtNlabel, tmpBuffer, NULL);
	}
}

/***************************************************************************
 *	PopupDiscDataDialog: ǥǡϿѤΥΥݥåץå
 *	
 *		void PopupDiscDataDialog(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupDiscDataDialog(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean enterMode;
	DiscDataEnter *discEnter = (DiscDataEnter*)client_data;
	Widget popupButton = discEnter->popdownInfo.popupWidget;
	Widget dialog = (Widget)discEnter->popdownInfo.client_data;
	int audioTrack;
	Position x, y;
	Dimension width, height;
	extern struct cd_toc CddaToc;
	
	if(discEnter->track != EOF)
		audioTrack = isAudioTrack(&CddaToc.track[discEnter->track]);
	else
		audioTrack = True;

	XtVaGetValues(enterDiscData, XtNstate, &enterMode, NULL);
	if(enterMode == True && audioTrack) {
		/*********************************************************
		 *	ݥåץåפεˤʤääȤ礭
		 *********************************************************/
		XtVaGetValues(popupButton, 
				XtNwidth, &width,
				XtNheight, &height,
				NULL);
		
		/***********************************
		 *	Root Window κɸϤѴ
		 ***********************************/
		XtTranslateCoords(popupButton,		/* Widget */
				(Position) 0,				/* x */
				(Position) height/2,		/* y */
				&x, &y);					/* coords on root window */

		/*******************************************************************
		 *	ݥåץåץΰ֤ꤹʤޤвƤʤ
		 *******************************************************************/
		XtVaSetValues(discEnter->popdownInfo.popdownShell, 
				XtNx, x,
				XtNy, y,
				NULL);
		/*
		XtVaSetValues(pEnterShell, 
				XtNx, x,
				XtNy, y,
				NULL);
		 */

		DialogDiscEnter_ptr = discEnter;
		if(discEnter->get_cdl_string != NULL) {
			discEnter->string_ptr = (*discEnter->get_cdl_string)(discEnter);
#ifdef	XAW_BUG
			XtVaSetValues(dialog, XtNvalue, 
						XtNewString(cdljc(discEnter->string_ptr)), NULL);
#else
			XtVaSetValues(dialog, XtNvalue, discEnter->string_ptr, NULL);
#endif	/*XAW_BUG*/
		}
		/*
		 *	XtVaSetValues(dialog, 
		 *		XtNvalue, 
		 *		((char*)CurrentDisc_ptr) + discEnter->string_offset, NULL);
		 */
		/*XtPopup(pEnterShell, XtGrabExclusive);*/
		XtPopup(discEnter->popdownInfo.popdownShell, XtGrabExclusive);
	}
}

/***************************************************************************
 *	DiscDataDialogSet: ǥǡϿ
 *	
 *		void DiscDataDialogSet(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void DiscDataDialogSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	DiscDataEnter *discEnter = *(DiscDataEnter**)client_data;
    Widget dialog = (Widget) discEnter->popdownInfo.client_data;
    String string;
    static char tooLongMessage[80];
    static char cnvBuffer[80];
	extern CddaDataForm *DiscData_ptr;
	extern CddaDataForm *CurrentDisc_ptr;

    /*****************************************************
     *	åȤϤʸ
     *****************************************************/
    string = XawDialogGetValueString(dialog);
    string2otherCodeset(cnvBuffer, sizeof(cnvBuffer), string, 
    					jcodesets[JaLoacle], jencodes[cdlFileEncode]);

	if(string != NULL && strlen(cnvBuffer) < discEnter->limit) {
		/* 顼 */
		sprintf(discEnter->string_ptr, "%.*s", 
										discEnter->limit - 1, cnvBuffer);
		if(discEnter->option_func != NULL) {
			(*discEnter->option_func)(discEnter);
		}
		if(CurrentDiscFlag == FALSE) {
			CurrentDiscFlag = True;
			DiscData_ptr = DiscDataMerge(CurrentDisc_ptr, DiscData_ptr);
		}
	} else {
		/*
		 *	sprintf(tooLongMessage, DiscDataErrors[StringTooLong], 
		 *							strlen(string), discEnter->limit-1);
		 */
		sprintf(tooLongMessage, "%s (%s:%d%s/%s:%d%s)", 
			keyword2mes("CdlStringTooLong"), 
			keyword2mes("String"),strlen(string), keyword2mes("Byte"), 
			keyword2mes("Limit"), discEnter->limit-1, keyword2mes("Byte"));
		DiscDataError = tooLongMessage;
		PopupMessage(DiscDataError);
	}
}

/***************************************************************************
 *	DiscDataDialogPopdown: ǥǡϿ
 *	
 *		void DiscDataDialogPopdown(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void DiscDataDialogPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	DiscDataEnter *discEnter = *(DiscDataEnter**)client_data;

	PopdownTargetShell(w, &discEnter->popdownInfo, NULL);
}

/***************************************************************************
 *	DiscDataDialogClear: ǥǡϿѤΥʸ󥯥ꥢ
 *	
 *		void DiscDataDialogClear(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void DiscDataDialogClear(Widget w, XtPointer client_data, XtPointer call_data)
{
    Widget dialog = (Widget)client_data;

    /*****************************************************
     *	åȤʸ򥯥ꥢ
     *****************************************************/
#ifdef	XAW_BUG
	XtVaSetValues(dialog, XtNvalue, XtNewString(""), NULL);
#else
	XtVaSetValues(dialog, XtNvalue, "", NULL);
#endif	/*XAW_BUG*/
}

/***************************************************************************
 *	DiscDataDialogWrdTop: 
 *	
 *		void DiscDataDialogWrdTop(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void DiscDataDialogWrdTop(Widget w, XtPointer client_data, XtPointer call_data)
{
    Widget dialog = (Widget)client_data;
	int track;
	char *topLine;
	extern int wordFileEncode;
	extern DiscWord *CurrentWords_ptr;
	XawListReturnStruct *selected = NULL;

	selected = XawListShowCurrent(DiscTrackList);
	track = selected->list_index;
	if(CurrentWords_ptr != NULL && track != XAW_LIST_NONE) {
		if(*(CurrentWords_ptr->trackWords + track) != NULL) {
			topLine = (*(CurrentWords_ptr->trackWords + track))->word;
			XtVaSetValues(dialog, XtNvalue, 
				string2otherEncodeNewString(topLine, 
					jcodesets[wordFileEncode], jencodes[JaLoacle]), NULL);
		}
	}
}

/***************************************************************************
 *	PopupDiscList: ץࡦꥹȤΥݥåץå׺ɸȤ
 *	
 *		void PopupDiscList(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;		topLevel ˥㥹Ȥ
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupDiscList(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget topLevel = (Widget) client_data;
	Position x, y;
	Dimension width, height;

	/*
	 *	topLevel widget 礭롣
	 */
	XtVaGetValues(topLevel, 
			XtNwidth, &width,
			XtNheight, &height,
			NULL);
	
	/*
	 *	topLevel widget Υ롼ȡɥΰ֤
	 */
	XtTranslateCoords(topLevel, 	/* Widget */
			(Position) width/2, 	/* x */
			(Position) height/2,	/* y */
			&x, &y); 				/* coords on root window */

	/*
	 *	ץࡦꥹȡݥåץåפΰ֤ꤹ롣
	 *	ʤޤԲĻξ֡
	 */
	XtVaSetValues(pDiscShell, 
			XtNx, x,
			XtNy, y,
			NULL);
	
	popupShellFlag = True;
}

/***************************************************************************
 *	PopdownDiscList: ץࡦꥹȤΥɥݥåץ󤹤
 *	
 *		void PopdownDiscList(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ץࡦꥹȤΥɥݥåץ󤷤ޤ
 ***************************************************************************/
/*ARGSUSED*/
void PopdownDiscList(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtPopdown(pDiscShell);
	XtSetSensitive(cmenupane[1], True);
	popupShellFlag = False;
}

#define is_crlf(string)	((*(string)) == '\r' && *((string)+1) == '\n')

/***************************************************************************
 *	is_cdlfile: ãģ̥ե뤫ɤñʥƥȤԤ
 *	
 *		int is_cdlfile(const char *filename);
 *	
 *		const char *filename;	ե̾
 *	֤
 *		ţϣơ	ãģ̥եǤϤʤ
 *				ãģ̥եǤʲǽ⤤
 *		ʾ塧	顼ȽǤʤե뤬¸ߤʤʤɡ
 *	
 *		եƬΣԤ顢ʰפΣãģ̥եƥȤԤ
 *		ƥȹܤϡʲ
 *		ǽιԤ%05d\r\nɤηǤ뤫
 *		ιԤ##\r\nɤǤ뤫
 ***************************************************************************/
int is_cdlfile(const char *filename)
{
	int status = 0;
	int counter;
	char buffer[256], *receive_ptr = NULL;
	FILE *stream;
	
	stream = fopen(filename, "rb");
	if(stream != NULL) {
		receive_ptr = fgets(buffer, sizeof(buffer), stream);
		if(receive_ptr != NULL) {
			for(counter = 0;counter < 5;++counter) {
				status |= !isdigit(*(buffer + counter));
			}
			status |= !is_crlf(buffer+5);
			receive_ptr = fgets(buffer, sizeof(buffer), stream);
			if(receive_ptr != NULL) {
				status |= (strcmp(buffer, "##\r\n") != 0);
			}
		}
		fclose(stream);
		if(receive_ptr != NULL) {
			status = ((status != 0)?(EOF):(0));
		}
	}
	if(receive_ptr == NULL) {
		status = errno;
	}
	return(status);
}

/***************************************************************************
 *	LoadDiscList: ץࡦꥹȤɤ߹
 *	
 *		void LoadDiscList(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ץࡦꥹȤɤ߹ߡ顼ʳʤ顢ץࡦꥹȡ
 *		ɥ򹹿롣
 ***************************************************************************/
/*ARGSUSED*/
void LoadDiscList(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status;
	CddaDataForm *newDiscData_ptr;
	String filename;
	extern struct cd_toc CddaToc;
	extern CddaDataForm *DiscData_ptr;
	extern CddaDataForm *CurrentDisc_ptr;

	XtVaGetValues(filenameDiscData, XtNstring, &filename, NULL);
	status = is_cdlfile(filename);
	if(status == 0) {
		newDiscData_ptr = MakeDiscsData(filename, app_data.space_delete);
		if(newDiscData_ptr != NULL) {
			releaseDiscData(DiscData_ptr);
			if(CurrentDiscFlag == FALSE) {
				releaseDiscData(CurrentDisc_ptr);
			}
			DiscData_ptr = newDiscData_ptr;
			cdlFileEncode = isCdlCodeset(DiscData_ptr);
			CurrentDisc_ptr = SearchDiscData(EOF, DiscData_ptr, &CddaToc);
			if(CurrentDisc_ptr == NULL) {
				CurrentDiscFlag = FALSE;
				CurrentDisc_ptr = 
						MakeNewDiscData(&CddaToc, app_data.space_delete);
			} else {
				CurrentDiscFlag = TRUE;
			}
			MakeDiscInfomation(CurrentDisc_ptr, &CddaToc);
			MakeProgramOrderList();
			make_cd_menu(&CddaToc);
		} else {
			PopupMessage("No Disc Data!!");
		}
	}
	switch(status) {
	default:
		DiscDataError = filename;
		if(DiscDataError == NULL)
			DiscDataError = "mwxcd:CDL File Load ";
		PopupSyserrMessage(DiscDataError);
		break;
	case EOF:		/* ꤵ줿ե뤬ãģ̥եηǤʤ */
		DiscDataError = keyword2mes("CdlIllegalFormat");
		PopupMessage(DiscDataError);
		break;
	case 0:			/* Normal End */
		break;
	}
}

/***************************************************************************
 *	backupNameAlloc: Хååסե̾Ƥ
 *	
 *		String backupNameAlloc(const char *filename);
 *	
 *		const char *filename;	
 *	֤
 *		NULL			顼ʥ­
 *		NULLʳ		Хååסե̾
 *	
 *		
 ***************************************************************************/
String backupNameAlloc(const char *filename)
{
	int separator;
	int counter, length;
	String alloc_ptr;
	
	counter = length = strlen(filename);
	do {
		--counter;
		switch(*(filename + counter) & 0x00ff) {
		case '/':
			separator = EOF;		/* ǥ쥯ȥζڤ˻ä */
			break;
		case '.':
			separator = TRUE;		/* եåζڤȽ   */
			break;
		default:
			separator = FALSE;		/* ڤɽʸǤϤʤ     */
			break;
		}
	} while(counter > 0 && separator == FALSE);
	if(separator != TRUE) {
		/*************************************************
		 *	եåζڤ򸫤ĤʤäȤ
		 *************************************************/
		counter = length;
	}
	length = counter + strlen(app_data.backup_suffix) + 1;
	alloc_ptr = (String) malloc(length);
	if(alloc_ptr != NULL) {
		sprintf(alloc_ptr, "%.*s%s", 
					counter, filename, app_data.backup_suffix);
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	moveBackup: ꤵ줿եХååץեˤ
 *	
 *		static int moveBackup(const char *filename);
 *	
 *		const char *filename;	
 *	֤
 *					顼ʤ
 *		ʳ		顼ֹ
 *	
 *		ꤵ줿ե͡षƥХååץեˤ롣
 ***************************************************************************/
static int moveBackup(const char *filename)
{
	int result = 0, status;
	String backupName;
	
	backupName = backupNameAlloc(filename);
	
	if(backupName != NULL) {
		result = status = is_cdlfile(backupName);
		switch(status) {
		default:
			DiscDataError = keyword2mes("CdlBackupError");
			break;
		case EOF:		/* Хååץե뤬ãģ̥եηǤʤ */
			DiscDataError = keyword2mes("CdlBackupIllegal");
			result = 0;
			break;
		case 0:			/* Normal End */
			break;
		case ENOENT:	/*	Хååסե뤬¸ߤʤ */
			result = status = 0;
			break;
		}
		if(result == 0) {
			result = is_cdlfile(filename);
			switch(result) {
			default:
				DiscDataError = filename;
				break;
			case EOF:		/* ꤵ줿ե뤬ãģ̥եηǤʤ */
				DiscDataError = keyword2mes("CdlIllegalFormat");
				break;
			case 0:			/* Normal End */
				result = status;
				if(result == 0) {
					if(rename(filename, backupName)) {
						result = errno;
						/*DiscDataError = keyword2mes("CdlRenameFaild");*/
					}
				}
				break;
			case ENOENT:	/*	ե뤬¸ߤʤ */
				result = 0;
				DiscDataError = NULL;
				break;
			}
		}
	} else {
		 DiscDataError = keyword2mes("CdlOutOfMemory");
		result = errno;
	}
#ifdef	DEBUG
	printf("backup filename = \"%s\"\n", 
				((backupName != NULL)?(backupName):("NULL Pointer")));
#endif	 /*DEBUG*/
	free(backupName);
	return(result);
}

/***************************************************************************
 *	SaveDiscList: ãģ̥ե񤭹
 *	
 *		void SaveDiscList(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ʲεǽޤ
 *		ϿEnter˥⡼ɤ
 *		ãģ̥ե񤭹ࡣ
 ***************************************************************************/
/*ARGSUSED*/
void SaveDiscList(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status;
	String filename;
	Boolean enterMode;
	extern CddaDataForm *DiscData_ptr;

	if(app_data.read_only == False) {
		DiscDataError = NULL;
		XtVaGetValues(enterDiscData, XtNstate, &enterMode, NULL);
		if(enterMode == True) {
			XtVaSetValues(enterDiscData, XtNstate, False, NULL);
			enterModeControl(enterDiscData, NULL, NULL);
		}
		XtVaGetValues(filenameDiscData, XtNstring, &filename, NULL);
		if((status = moveBackup(filename)) == 0) {
			SaveDiscsData(filename, DiscData_ptr);
		} else {
			switch(status) {
			case EOF:
				PopupMessage(DiscDataError);
				break;
			default:
				if(DiscDataError == NULL)
					DiscDataError = filename;
				if(DiscDataError == NULL)
					DiscDataError = "mwxcd:CDL File Save ";
				PopupSyserrMessage(DiscDataError);
				break;
			}
		}
	}
}

/***************************************************************************
 *	FlashControl: ǥꥹȤαնɽ椹륢
 *	
 *		void FlashControl(Widget w, XEvent *event,
 *							String *params, Cardinal *num_params);
 *	
 *		Widget w;					̤
 *		XEvent *event;				̤
 *		String *params;				̤
 *		Cardinal *num_params;		̤
 *	
 *		ºݤˤϡΰǻꤵ줿åȤδ
 *		ޤ
 *	ѷ
 *		flashControl();		
 *							ꤷʤϡΥ򵯤
 *							åȤ󥻥󥷥ƥ֥⡼ɤˤʤޤ
 *		flashControl(True);	True/False ʤɤ Boolean 򼨤ʸΤȤϡ
 *							Υ򵯤åȤ
 *							ꤷޤ
 *		flashControl(widget, True);
 *							ꤵ줿̾ΥäȤδꤷޤ
 ***************************************************************************/
void FlashControl(Widget w, XEvent *event,
							String *params, Cardinal *num_params)
{
	Widget target = NULL;
	Boolean flag;
	XrmValue from, to;
	extern Widget topLevel;

	switch((int)*num_params) {
	default:	/* ΰ¿Ȥ */
		XtWarning("Too many parameter passed to flashControl action table.");
		break;
	case 0:		/* ΰꤵƤʤȤ */
		XtSetSensitive(w, False);
		break;
	case 2:		/* ˥å̾ȴ򼨤 */
		target = XtNameToWidget(topLevel, *params);
		if(target == NULL) {
			/*******************************************
			 *	åȤǤʤƤʤȤ
			 *******************************************/
			break;
		}
		++params;
		/* to be continued...: ʲ case ³ޤ */
	case 1:
		if(target == NULL) {
			target = w;
		}
		from.size = strlen(from.addr = *params);
		to.addr = &flag;
		to.size = sizeof(flag);
		if(XtConvertAndStore(w, XtRString, &from, XtRBoolean, &to) == False) {
			XtAppError(XtWidgetToApplicationContext(w), 
						"flashControl action: String to Boolean "
						"conversion failed");
		} else {
			XtSetSensitive(target, flag);
		}
		break;
	}
}

/***************************************************************************
 *	DiscTrackSelect: ץࡦꥹȤΥȥåܤ򤵤줿
 *	
 *		void (Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void DiscTrackSelect(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean enterMode;
	DiscDataEnter *discEnter = (DiscDataEnter*)client_data;
	XawListReturnStruct *list_ptr = (XawListReturnStruct*)call_data;
	extern struct cd_toc CddaToc;
	extern int TrackNumbers[];
	
	XtVaGetValues(enterDiscData, XtNstate, &enterMode, NULL);
	if(list_ptr->list_index >= 0 &&
			list_ptr->list_index <= CddaToc.e_track - CddaToc.s_track) {
		switch(enterMode) {
		case False:				/* Non-Enter Mode */
			TrackMenuSelect(w, &TrackNumbers[list_ptr->list_index], NULL);
			break;
		case True:				/* Enter Mode */
			discEnter->track = TrackNumbers[list_ptr->list_index];
			break;
		}
	}
}

/***************************************************************************
 *	string_count: ޥɥ饤ʸ󤫤 argc 
 *	
 *		int string_count(const char *arg_string);
 *	
 *		const char *arg_string;		ޥɥ饤ʸ
 *	֤
 *		ο
 ***************************************************************************/
int string_count(const char *arg_string)
{
	int counter = 0;

	if(arg_string != NULL) {
		while(*arg_string != '\0') {
			while(*arg_string == ' ' && *arg_string != '\0')
				++arg_string;
			if(*arg_string != '\0') {
				++counter;
				while(*arg_string != ' ' && *arg_string != '\0')
					++arg_string;
			}
		}
	}
	return (counter);
}

/***************************************************************************
 *	chr_count: ޤϡʸޤǤʸ
 *	
 *		int chr_count(const char *arg_string)
 *	
 *		const char *arg_string;
 *	֤
 *		ޤϡʸޤǤʸ
 ***************************************************************************/
int chr_count(const char *arg_string)
{
	int counter = 0;

	while(*arg_string != ' ' && *arg_string != '\0') {
		++counter;
		++arg_string;
	}
	return (counter);
}

/***************************************************************************
 *	strings_free: ʸΥݥ
 *	
 *		void strings_free(char **strings);
 *	
 *		char **strings;
 ***************************************************************************/
void strings_free(char **strings)
{
	int counter = 0;

	if(strings != NULL) {
		for(counter = 0;*(strings + counter) != NULL;++counter) {
			free(*(strings + counter));
		}
		free(strings);
	}
}

/***************************************************************************
 *	strings_make: argv 
 *	
 *		char **strings_make(const char *arg_string);
 *	
 *		const char *arg_string;		ޥɥ饤ʸ
 *	֤
 *		NULL		­
 *		NULLʳ	argv 
 ***************************************************************************/
char **strings_make(const char *arg_string)
{
	int n;
	int len;
	int counter = 0;
	char **strings = NULL;
	
	n = string_count(arg_string);
	if(arg_string != NULL && n > 0) {
		strings = (char**)malloc(sizeof(char*) * (n+1));
		for(counter = 0;counter <= n;++counter)
			*(strings + counter) = NULL;
		if(strings != NULL) {
			for(counter = 0;counter < n && *arg_string != '\0';++counter) {
				while(*arg_string == ' ' && *arg_string != '\0') {
					++arg_string;
				}
				if(*arg_string != '\0') {
					len = chr_count(arg_string);
					*(strings + counter) = (char*)malloc(len+1);
					if(*(strings + counter) != NULL)
						sprintf(*(strings + counter), "%.*s", len, arg_string);
					else {
						strings_free(strings);
						return(NULL);
					}
					arg_string += len;
				}
			}
		}
	}
	return (strings);
}

/***************************************************************************
 *	tiffExec: TIFF ӥ奢ư
 *	
 *		int tiffExec(char *arg_string)
 *	
 *		char *arg_string;
 *
 ***************************************************************************/
int tiffExec(char *arg_string)
{
	int status;
	char **arg_ptr_ptr;
	static char arg_buffer[4096];
	extern volatile int ViwerPid;

	if(strlen(arg_string) > sizeof(arg_buffer) - 2) {
		return(-1);
	}
	sprintf(arg_buffer, "%.*s", (int)sizeof(arg_buffer) - 2, arg_string);
	signal(SIGCLD, quit_child_pocess);
	if ((ViwerPid = fork()) < 0) {
		perror("fork");
		exit(1);
	}
#ifdef	TIFF_DEBUG
	printf("%s(%d):fork() --------- %3d: Viwer Process. -- make.\n", __FILE__, __LINE__, ViwerPid);
#endif	/*TIFF_DEBUG*/
	if (ViwerPid == 0) {
		/***************
		 *	ҥץ
		 ***************/
		arg_ptr_ptr = strings_make(arg_buffer);
		
		if (arg_ptr_ptr != NULL) {
			status = execvp(*arg_ptr_ptr, arg_ptr_ptr);
#ifdef	TIFF_DEBUG
			printf("%s(%d):execvp() = %d\n", __FILE__, __LINE__, status);
#endif	/*TIFF_DEBUG*/
			strings_free(arg_ptr_ptr);
			perror(*arg_ptr_ptr);
		}
		exit(1);
	}
	return (ViwerPid);
}

/***************************************************************************
 *	TiffViewer: TIFF ե̾å줿
 *	
 *		void TiffViewer(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void TiffViewer(Widget w, XtPointer client_data, XtPointer call_data)
{
	int len;
	int status;
	Boolean enterMode;
	String tiff_string;
	String arg_string;
	String file_string;
	clock_t limitTime;
	extern volatile int ViwerPid;
	extern String TiffViewerCall;
	extern char **TiffSuffixList;

#ifdef	TIFF_DEBUG
	printf("%s:%d:TiffViewer();\n", __FILE__, __LINE__);
#endif	/*TIFF_DEBUG*/
	if(ViwerPid != 0) {
#ifdef	TIFF_DEBUG
		printf("Kill: Target --- %3d.\n", ViwerPid);
		fflush(stdout);
#endif	/*TIFF_DEBUG*/
		XtSetSensitive(DiscTiff, False);
		status = kill(ViwerPid, SIGKILL);
#ifdef	TIFF_DEBUG
		printf("kill status -- <<<%3d>>>   Sending Process ID = (%3d)\n", 
														status, getpid());
		fflush(stdout);
#endif	/*TIFF_DEBUG*/
		limitTime = clock() + CLK_TCK * 5 + 1;	/* 56äλԤ */
		while(ViwerPid != 0 && clock() < limitTime) 
			;					/* :ԤΤ */
#ifdef	TIFF_DEBUG
		printf("<<< Killed: --- %3d.\n", ViwerPid);
#endif	/*TIFF_DEBUG*/
		ViwerPid = 0;
		XtSetSensitive(DiscTiff, True);
	}
	XtVaGetValues(enterDiscData, XtNstate, &enterMode, NULL);
	if(app_data.tiffDisplayable && 
				enterMode == False && TiffViewerCall != NULL) {
		if(CurrentDisc_ptr != NULL) {
			if(strlen(CurrentDisc_ptr->tiffFile) > 0) {
				file_string = searchFileName(app_data.tiffDirpath, 
									CurrentDisc_ptr->tiffFile, 
									(const char**)TiffSuffixList);
			} else {
				file_string = NULL;
			}
			if(file_string != NULL) {
				tiff_string = (char*)malloc(strlen(app_data.tiffDirpath) +
												strlen(file_string) + 2);
				if(tiff_string != NULL) {
					sprintf(tiff_string, "%s/%s", 
								app_data.tiffDirpath, file_string);
					len = strlen(TiffViewerCall) + strlen(tiff_string) + 1;
					arg_string = (String)malloc(len);
					if(arg_string != NULL) {
						sprintf(arg_string, TiffViewerCall, tiff_string);
						tiffExec(arg_string);
						free(arg_string);
					}
					free(tiff_string);
					free(file_string);
				}
			}
		}
	}
}

/***************************************************************************
 *	MakeDiscInfomation: ǥ󥦥ɥ򹹿
 *	
 *		void MakeDiscInfomation(CddaDataForm *disc_data, 
 *											struct cd_toc *toc);
 *	
 *		CddaDataForm *disc_data;	ãģ̥ե
 *		struct cd_toc *toc;			ãľʣԣϣ:Table Of Contents
 *	
 *		
 ***************************************************************************/
void MakeDiscInfomation(CddaDataForm *disc_data, struct cd_toc *toc)
{
	int counter;
	TrackData *track_ptr;
	long int toc_frame;
	XWindowAttributes rootAttr;
	
	if(disc_data != NULL) {
		XtVaSetValues( DiscTitle, XtNlabel,     cdljc(disc_data->cdTitle), NULL);
		XtVaSetValues(DiscArtist, XtNlabel,      cdljc(disc_data->artist), NULL);
		XtVaSetValues( DiscLabel, XtNlabel,       cdljc(disc_data->label), NULL);
		XtVaSetValues(  DiscDate, XtNlabel, cdljc(disc_data->releaseDate), NULL);
		XtVaSetValues(  DiscTiff, XtNlabel,    cdljc(disc_data->tiffFile), NULL);
		XtVaSetValues( DiscWords, XtNlabel,  cdljc(disc_data->lyricsFile), NULL);
		track_ptr = disc_data->track_ptr;
		for(counter = 0;counter < disc_data->tracks;++counter, ++track_ptr) {
			toc_frame = TrackFrames(counter + toc->s_track, toc);
			if(isDataTrack(&toc->track[counter])) {
				sprintf(TrackString[counter], "%2d. %2d:%02d.%02d  %s", 
						counter + toc->s_track, (int)toc_frame/4500, 
						(int)(toc_frame/75)%60, (int)toc_frame%75,
						app_data.data_track_title);
			} else {
				sprintf(TrackString[counter], "%2d. %2d:%02d.%02d  %s", 
						counter + toc->s_track,
						(int)toc_frame / 4500, (int)(toc_frame / 75) % 60, 
						(int)toc_frame % 75, cdljc(track_ptr->trackTitle));
			}
		}
		if(!app_data.cdlAutoHeight) {
			resize_check(DiscView,  disc_data->tracks, app_data.cdDataListResize);
		}
		if(app_data.cdlAutoHeight) {
			XtVaSetValues(DiscView, XtNallowVert, False, NULL);
			if(!XtIsRealized(DiscView)) {
				XmwGetWindowInfo(DiscView, NULL, &rootAttr);
				/* XtVaSetValues(DiscView, XtNmax, rootAttr.height - 150, NULL); */
			}
		}
		XawListChange(DiscTrackList, TrackString, disc_data->tracks, 0, True);
		if(app_data.cdlAutoHeight) {
			autoMaxHeight(DiscView);
			XtVaSetValues(DiscView, XtNallowVert, True, NULL);
		}
	}
}

/***************************************************************************
 *	compactDiscDataError: ãľ󤬼Ǥ̵Ȥν
 *	
 *		void compactDiscDataError(void);
 *	
 *		ãľ󤬼Ǥ̵ȤΰʲνԤ
 *		Compact Disc DataɤΥݥåץ
 *		Compact Disc DataɤΥݥåץåס˥塼ԲĤˤ
 ***************************************************************************/
void compactDiscDataError(void)
{
	if(XtIsSensitive(cmenupane[1]) == True) {
		/**********************************
		 *	Compact Disc Dataɤɽ
		 **********************************/
		XtSetSensitive(cmenupane[1], False);
	} else {
		/**********************************
		 *	Compact Disc Dataɤɽ
		 **********************************/
		popupShellFlag = False;
		XtPopdown(pDiscShell);
	}
}

/***************************************************************************
 *	compactDiscOut: ǥ򴹤ȼCompact Disc Dataɤؤν
 *	
 *		void compactDiscOut(void);
 *	
 *		
 ***************************************************************************/
void compactDiscOut(void)
{
	Boolean enterMode;
	
	XtVaGetValues(enterDiscData, XtNstate, &enterMode, NULL);
	if(enterMode == True) {
		XtVaSetValues(enterDiscData, XtNstate, False, NULL);
	}
	XtSetSensitive(enterDiscData, False);

	XtSetSensitive(DiscTitle, False);
	XtSetSensitive(DiscArtist, False);
	XtSetSensitive(DiscDate, False);
	XtSetSensitive(DiscLabel, False);
	XtSetSensitive(DiscTiff, False);
	XtSetSensitive(DiscWords, False);
	XtSetSensitive(DiscTrackList, False);
	wordsCompactDiscOut();
}

/***************************************************************************
 *	compactDiscIn: ǥ򴹤ȼCompact Disc Dataɤؤν򴹸
 *	
 *		void compactDiscIn(void);
 *	
 *		
 ***************************************************************************/
void compactDiscIn(void)
{
	XtSetSensitive(DiscTitle, True);
	XtSetSensitive(DiscArtist, True);
	XtSetSensitive(DiscDate, True);
	XtSetSensitive(DiscLabel, True);
	XtSetSensitive(DiscTiff, True);
	XtSetSensitive(DiscWords, True);
	XtSetSensitive(DiscTrackList, True);

	XtSetSensitive(enterDiscData, True);
	if(popupShellFlag == False) {
		XtSetSensitive(cmenupane[1], True);
	}
	wordsCompactDiscIn();
}

/***************************************************************************
 *	enterModeControl: Ͽ⡼ɡꡦ
 *	
 *		void enterModeControl(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w; 				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
void enterModeControl(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean enterMode;
	
	XtVaGetValues(w, XtNstate, &enterMode, NULL);
	XtSetSensitive(DiscTiffSelect, enterMode);
	XtVaSetValues(DiscTiffSelect, 
					XtNbitmap, (enterMode?diskMark:diskDisable), NULL);
	XtSetSensitive(DiscWordsSelect, enterMode);
	XtVaSetValues(DiscWordsSelect, 
					XtNbitmap, (enterMode?diskMark:diskDisable), NULL);
}

/***************************************************************************
 *	cdl_dialog_set: ǥǡϿѤΥХåؿꤹ
 *	
 *		void cdl_dialog_set(DiscDataEnter *discEnter, Widget popupButton, 
 *				int limit, int string_offset, int track, 
 *				String (*get_cdl_string)(struct _discDataEnter *discEnter), 
 *					void (*option_func)(struct _discDataEnter *discEnter));
 *	
 *		DiscDataEnter *discEnter;	ǥǡϿѾ
 *		Widget popupButton;
 *		int limit;
 *		int string_offset;
 *		int track;
 *		String (*get_cdl_string)(struct _discDataEnter *discEnter);
 *		void (*option_func)(struct _discDataEnter *discEnter);
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void cdl_dialog_set(DiscDataEnter *discEnter, Widget popupButton, 
			int limit, int string_offset, int track, 
				String (*get_cdl_string)(struct _discDataEnter *discEnter), 
					void (*option_func)(struct _discDataEnter *discEnter))
{
	discEnter->option_func = option_func;
	discEnter->get_cdl_string = get_cdl_string;
	discEnter->limit = limit;
	discEnter->string_offset = string_offset;
	discEnter->track = track;
	discEnter->popdownInfo.popdownShell = pEnterShell;
	discEnter->popdownInfo.popupWidget = popupButton;
	discEnter->popdownInfo.client_data = (XtPointer)discDataDialog;

	XtAddCallback(discEnter->popdownInfo.popupWidget, 
							XtNcallback, PopupDiscDataDialog, discEnter);
	/*
	 *	XtAddCallback(discEnter->popdownInfo.popupWidget, 
	 *						XtNcallback, XtCallbackExclusive, pEnterShell);
	 */
}

/***************************************************************************
 *	cdl_track_dialog_set: ǥǡϿѤΥХåؿꤹ
 *	
 *		void cdl_track_dialog_set(DiscDataEnter *discEnter, 
 *			Widget popupButton, int limit, int string_offset, int track, 
 *				String (*get_cdl_string)(struct _discDataEnter *discEnter), 
 *					void (*option_func)(struct _discDataEnter *discEnter));
 *	
 *		DiscDataEnter *discEnter;	ǥǡϿѾ
 *		Widget popupButton;
 *		int limit;
 *		int string_offset;
 *		int track;
 *		String (*get_cdl_string)(struct _discDataEnter *discEnter);
 *		void (*option_func)(struct _discDataEnter *discEnter);
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void cdl_track_dialog_set(DiscDataEnter *discEnter, Widget popupButton, 
			int limit, int string_offset, int track, 
				String (*get_cdl_string)(struct _discDataEnter *discEnter), 
					void (*option_func)(struct _discDataEnter *discEnter))
{
	discEnter->option_func = option_func;
	discEnter->get_cdl_string = get_cdl_string;
	discEnter->limit = limit;
	discEnter->string_offset = string_offset;
	discEnter->track = track;
	discEnter->popdownInfo.popdownShell = trackShell;
	discEnter->popdownInfo.popupWidget = popupButton;
	discEnter->popdownInfo.client_data = (XtPointer)trackDataDialog;

	XtAddCallback(discEnter->popdownInfo.popupWidget, 
							XtNcallback, PopupDiscDataDialog, discEnter);
	/*
	 *	XtAddCallback(discEnter->popdownInfo.popupWidget, 
	 *						XtNcallback, XtCallbackExclusive, pEnterShell);
	 */
}

/***************************************************************************
 *	cdl_dialog_init: ǥǡϿѤΥޤॷ
 *	
 *		Widget cdl_dialog_init(Widget parent);
 *	
 *		Widget parent;		ƥå
 *	
 *		
 ***************************************************************************/
Widget cdl_dialog_init(Widget parent)
{
	pEnterShell = XtCreatePopupShell(
			"pEnterShell",
			transientShellWidgetClass,
			parent,
			NULL,
			0
			);

	discDataDialog = XtCreateManagedWidget(
			"discDataDialog",				/* widget name   */
			dialogWidgetClass,		/* widget class */
			pEnterShell,					/* parent widget*/
			NULL,							/* argument list*/
			0								/* arglist size */
			);

	XawDialogAddButton(discDataDialog, "clear",
								DiscDataDialogClear, discDataDialog);

	XawDialogAddButton(discDataDialog, "set",
				DiscDataDialogSet, &DialogDiscEnter_ptr);

	XawDialogAddButton(discDataDialog, "popdown",
							DiscDataDialogPopdown, &DialogDiscEnter_ptr);

	return(pEnterShell);
}

/***************************************************************************
 *	cdl_track_dialog_init: TRACK ζ̾Ͽѥ
 *	
 *		Widget cdl_track_dialog_init(Widget parent);
 *	
 *		Widget parent;	ƥå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
Widget cdl_track_dialog_init(Widget parent)
{
	trackShell = XtCreatePopupShell(
			"trackShell",
			transientShellWidgetClass,
			parent,
			NULL,
			0
			);

	trackDataDialog = XtCreateManagedWidget(
			"trackDataDialog",				/* widget name   */
			dialogWidgetClass,		/* widget class */
			trackShell,					/* parent widget*/
			NULL,							/* argument list*/
			0								/* arglist size */
			);

	XawDialogAddButton(trackDataDialog, "clear",
								DiscDataDialogClear, trackDataDialog);

	XawDialogAddButton(trackDataDialog, "wordTop",
								DiscDataDialogWrdTop, trackDataDialog);

	XawDialogAddButton(trackDataDialog, "set",
				DiscDataDialogSet, &DialogDiscEnter_ptr);

	XawDialogAddButton(trackDataDialog, "popdown",
							DiscDataDialogPopdown, &DialogDiscEnter_ptr);

	return(trackShell);
}

/***************************************************************************
 *	FlashingDiscData: Υץΰ֥եå夵
 *	
 *		void FlashingDiscData(void);
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void FlashingDiscData(void)
{
	Boolean flashingMode;
	static Boolean flashingFlag = False;
	extern int CdTrack;
	
	XtVaGetValues(discDataFlashing, XtNstate, &flashingMode, NULL);
	if(flashingMode == True)
		flashingMode = XtIsSensitive(discDataFlashing);

	if(flashingMode == True && CdTrack > 0) {
		flashingFlag = ((flashingFlag == False)?(True):(False));
		if(flashingFlag == True)
			XawListHighlight(DiscTrackList, CdTrack - 1);
		else
			XawListUnhighlight(DiscTrackList);
	}
}

/***************************************************************************
 *	cdlSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void cdlSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void cdlSelectFinish(const char *dirName, const char *fileName)
{
	char filepath[4096];

	sprintf(filepath, "%s/%s", dirName, fileName);
#ifdef	XAW_BUG
	XtVaSetValues(filenameDiscData, XtNstring, XtNewString(filepath), NULL);
#else
	XtVaSetValues(filenameDiscData, XtNstring, filepath, NULL);
#endif	/*XAW_BUG*/
}

/***************************************************************************
 *	cdlFileSelector: ե롦쥯ƤӽФ
 *	
 *		void cdlFileSelector(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void cdlFileSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String filepath;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[1];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	XtVaGetValues(filenameDiscData, XtNstring, &filepath, NULL);
	dirName[0] = '\0';
	fileName[0] = '\0';
	fileCheck(filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, cdlSelectFinish);
}

/***************************************************************************
 *	tiffSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void tiffSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void tiffSelectFinish(const char *dirName, const char *fileName)
{
	char *suffix_ptr;
	char filepath[4096];

	suffix_ptr = strchr(fileName, '.');
	if(suffix_ptr != NULL) {
		sprintf(filepath, "%.*s", suffix_ptr - fileName, fileName);
		sprintf(CurrentDisc_ptr->tiffFile, "%.*s", 
				(int)sizeof(CurrentDisc_ptr->tiffFile) - 1, filepath);
		XtVaSetValues(DiscTiff, XtNlabel, filepath, NULL);
	}
}

/***************************************************************************
 *	tiffFileSelector: ե롦쥯ƤӽФ
 *	
 *		void tiffFileSelector(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void tiffFileSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String file_string;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[3];
	static selectorPanes *defSort = &fileSortPaneInfo[1];
	extern char **TiffSuffixList;

	sprintf( dirName, "%.*s", (int)sizeof(dirName) - 1, app_data.tiffDirpath);
	file_string = 
		searchFileName(app_data.tiffDirpath, 
				CurrentDisc_ptr->tiffFile, (const char**)TiffSuffixList);
	if(file_string != NULL) {
		sprintf(fileName, "%.*s", (int)sizeof(fileName) - 1, file_string);
		free(file_string);
	} else {
		fileName[0] = '\0';
	}
	fileSelectorCall(w, dirName, defPickup, defSort, tiffSelectFinish);
}

/***************************************************************************
 *	wordsSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void wordsSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void wordsSelectFinish(const char *dirName, const char *fileName)
{
	char *suffix_ptr;
	char filepath[4096];

	suffix_ptr = strchr(fileName, '.');
	if(suffix_ptr != NULL) {
		sprintf(filepath, "%.*s", suffix_ptr - fileName, fileName);
		sprintf(CurrentDisc_ptr->lyricsFile, "%.*s", 
					(int)sizeof(CurrentDisc_ptr->lyricsFile) - 1, filepath);
		XtVaSetValues(DiscWords, XtNlabel, filepath, NULL);
	}
}

/***************************************************************************
 *	wordsFileSelector: ե롦쥯ƤӽФ
 *	
 *		void wordsFileSelector(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void wordsFileSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[2];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	sprintf( dirName, "%s", app_data.wordsDirpath);
	sprintf(fileName, "%s.wrd", CurrentDisc_ptr->lyricsFile);
	fileSelectorCall(w, dirName, defPickup, defSort, wordsSelectFinish);
}

/***************************************************************************
 *	DiscData_init: ޥɡ˥塼ץࡦꥹȤνԤ
 *	
 *		void DiscData_init(Widget topLevel, Widget cd_panel, Widget popupButton);
 *	
 *		Widget topLevel;
 *		Widget cd_panel;
 *		Widget popupButton;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void DiscData_init(Widget topLevel, Widget cd_panel, Widget popupButton)
{
	Widget compactDiscData, saveDiscData, loadDiscData, discDataSelect;
	int i;
	static DiscDataEnter popdownTitleEnter, popdownArtistEnter;
	static DiscDataEnter popdownTiffEnter; 
	static DiscDataEnter popdownDateEnter, popdownLabelEnter;
	static DiscDataEnter popdownWordsEnter;
	static DiscDataEnter popdownTrackEnter;

	/***************************************
	 *	ãģ̥ǡδϢå
	 ***************************************/
	pDiscShell = XtVaCreatePopupShell(
			"pDiscShell",
			topLevelShellWidgetClass,
			topLevel,
			NULL
			);

	DiscBlock = XtVaCreateManagedWidget(
			"discBlock", 				/* widget name   */
			panedWidgetClass, 			/* widget class */
			pDiscShell, 				/* parent widget*/
			NULL 						/* argument list*/
			);

	compactDiscData = XtVaCreateManagedWidget(
			"compactDiscData", 		/* widget name   */
			panedWidgetClass,	 	/* widget class */
			DiscBlock, 				/* parent widget */
			XtNorientation, XtorientHorizontal,
			NULL 					/* argument list */
			);
	
	popdownDisc = XtVaCreateManagedWidget(
			"popdownDiscData", 		/* widget name   */
			commandWidgetClass, 	/* widget class */
			compactDiscData, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	discDataFlashing = XtVaCreateManagedWidget(
			"discDataFlashing", 	/* widget name   */
			toggleWidgetClass, 		/* widget class */
			compactDiscData, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	enterDiscData = XtVaCreateManagedWidget(
			"enterDiscData", 		/* widget name   */
			toggleWidgetClass, 		/* widget class */
			compactDiscData, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	saveDiscData = XtVaCreateManagedWidget(
			"saveDiscData", 		/* widget name   */
			commandWidgetClass, 	/* widget class */
			compactDiscData, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	loadDiscData = XtVaCreateManagedWidget(
			"loadDiscData", 		/* widget name   */
			commandWidgetClass, 	/* widget class */
			compactDiscData, 		/* parent widget */
			NULL 					/* argument list */
			);
	
	sprintf(DiscDataFilename, "%.*s", 
			(int)sizeof(DiscDataFilename) - 1, app_data.cdl_file);

	filenameDiscData = XtVaCreateManagedWidget(
			"filenameDiscData", 		/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			compactDiscData, 			/* parent widget */
			XtNeditType, 			XawtextEdit,
			XtNtype,				XawAsciiString,	
			XtNlength,				sizeof(DiscDataFilename) - 1,
			XtNstring,				DiscDataFilename, 
			NULL 					/* argument list */
			);
	
	discDataSelect = XtVaCreateManagedWidget(
			"discDataSelect", 		/* widget name   */
			commandWidgetClass, 	/* widget class */
			compactDiscData, 		/* parent widget */
			XtNbitmap, diskMark,
			NULL 					/* argument list */
			);
	
	DiscTitle = XtVaCreateManagedWidget(
			"discTitle", 				/* widget name   */
			commandWidgetClass, 	/* widget class */
			DiscBlock, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	DiscArtist = XtVaCreateManagedWidget(
			"discArtist", 				/* widget name   */
			commandWidgetClass, 	/* widget class */
			DiscBlock, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	DiscDataOuter = XtVaCreateManagedWidget(
			"discDataOuter", 			/* widget name   */
			panedWidgetClass, 			/* widget class */
			DiscBlock, 					/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list*/
			);

	DiscDataInner = XtVaCreateManagedWidget(
			"discDataInner", 			/* widget name   */
			panedWidgetClass, 			/* widget class */
			DiscDataOuter, 				/* parent widget*/
			NULL 						/* argument list*/
			);

	DiscData1 = XtVaCreateManagedWidget(
			"discData1", 				/* widget name   */
			panedWidgetClass, 			/* widget class */
			DiscDataInner, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list*/
			);

	DiscLabelLogo = XtVaCreateManagedWidget(
			"discLabelLogo", 			/* widget name   */
			labelWidgetClass, 			/* widget class */
			DiscDataOuter, 				/* parent widget*/
			NULL 						/* argument list*/
			);

	DiscDate = XtVaCreateManagedWidget(
			"discDate", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			DiscData1, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	DiscLabel = XtVaCreateManagedWidget(
			"discLabel", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			DiscData1, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	DiscData2 = XtVaCreateManagedWidget(
			"discData2", 				/* widget name   */
			panedWidgetClass, 			/* widget class */
			DiscDataInner, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list*/
			);

	DiscTiff = XtVaCreateManagedWidget(
			"discTiff", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			DiscData2, 					/* parent widget */
			NULL 						/* argument list*/
			);

	DiscTiffSelect = XtVaCreateManagedWidget(
			"discTiffSelect", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			DiscData2, 					/* parent widget */
			XtNbitmap, diskDisable,
			NULL 						/* argument list*/
			);

	DiscWords = XtVaCreateManagedWidget(
			"DiscWords", 				/* widget name */
			commandWidgetClass, 		/* widget class */
			DiscData2, 					/* parent widget */
			NULL 						/* argument list */
			);

	DiscWordsSelect = XtVaCreateManagedWidget(
			"DiscWordsSelect", 			/* widget name */
			commandWidgetClass, 		/* widget class */
			DiscData2, 					/* parent widget */
			XtNbitmap, diskDisable,
			NULL 						/* argument list */
			);

	DiscView = XtVaCreateManagedWidget(
			"DiscView", 				/* widget name   */
			viewportWidgetClass, 		/* widget class */
			DiscBlock, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	DiscTrackList = XtVaCreateManagedWidget(
			"discTrackList", 			/* widget name   */
			listWidgetClass, 		/* widget class */
			DiscView, 					/* parent widget */
			NULL 						/* argument list */
			);

	XtAddCallback(popupButton, XtNcallback, PopupDiscList, cd_panel);
	if(!app_data.cdlAutoHeight) {
		XtAddCallback(popupButton, XtNcallback, XtCallbackNone, pDiscShell);
	} else {
		/*
		XtAddCallback(popupButton, XtNcallback, 
								XmwCallbackNoneLVAutoHeight, DiscTrackList);
		 */
		XtAddCallback(popupButton, XtNcallback, 
										XmwCallbackNoneAutoHeight, DiscView);
	}
	XtAddCallback(popdownDisc, XtNcallback, PopdownDiscList, 0);
	XtAddCallback(DiscTrackList, 
						XtNcallback, DiscTrackSelect, &popdownTrackEnter);

	XtAddCallback(loadDiscData, XtNcallback, LoadDiscList, 0);
	XtAddCallback(saveDiscData, XtNcallback, SaveDiscList, 0);
	XtSetSensitive(saveDiscData, ((app_data.read_only)?(False):(True)));
	XtAddCallback(enterDiscData, XtNcallback, enterModeControl, NULL);
	XtAddCallback(DiscTiff, XtNcallback, TiffViewer, NULL);
	XtAddCallback(discDataSelect, XtNcallback, cdlFileSelector, NULL);
	XtAddCallback(DiscTiffSelect , XtNcallback, tiffFileSelector, NULL);
	XtAddCallback(DiscWordsSelect , XtNcallback, wordsFileSelector, NULL);

	cdl_dialog_init(DiscBlock);
	cdl_track_dialog_init(DiscBlock);
	cdl_dialog_set(&popdownTitleEnter, DiscTitle, 
			sizeof(CurrentDisc_ptr->cdTitle), 
			&DummyDiscData.cdTitle[0] - &DummyDiscData.cdTitle[0], EOF, 
			GetCddaDataPosition, SetLabelString);
	cdl_dialog_set(&popdownArtistEnter, DiscArtist,
			sizeof(CurrentDisc_ptr->artist), 
			&DummyDiscData.artist[0] - &DummyDiscData.cdTitle[0], EOF,
			GetCddaDataPosition, SetLabelString);
	cdl_dialog_set(&popdownLabelEnter, DiscLabel, 
			sizeof(CurrentDisc_ptr->label), 
			&DummyDiscData.label[0] - &DummyDiscData.cdTitle[0], EOF, 
			GetCddaDataPosition, SetLabelString);
	cdl_dialog_set(&popdownDateEnter, DiscDate, 
			sizeof(CurrentDisc_ptr->releaseDate), 
			&DummyDiscData.releaseDate[0] - &DummyDiscData.cdTitle[0], EOF, 
			GetCddaDataPosition, SetLabelString);
	cdl_dialog_set(&popdownTiffEnter, DiscTiff, 
			sizeof(CurrentDisc_ptr->tiffFile), 
			&DummyDiscData.tiffFile[0] - &DummyDiscData.cdTitle[0], EOF, 
			GetCddaDataPosition, SetLabelString);
	cdl_dialog_set(&popdownWordsEnter, DiscWords, 
			sizeof(CurrentDisc_ptr->lyricsFile), 
			&DummyDiscData.lyricsFile[0] - &DummyDiscData.cdTitle[0], EOF, 
			GetCddaDataPosition, SetLabelString);
	cdl_track_dialog_set(&popdownTrackEnter, DiscTrackList, 
			sizeof(CurrentDisc_ptr->track_ptr->trackTitle), 0, 0, 
			GetDiscDataTrackPosition, RenewalDiscList);

	for(i = 0;i < 100;++i) {
		TrackString[i] = (char*)malloc(80);
	}
}

