/***************************************************************************
 *	cd_word.h: ãıյǽ
 *		
 *		Version 1.10 1995/04/19 -- 
 *		Version 1.50 1997/09/1? -- 
 *		
 *			Programmed by Nobuyuki Maruichi
 *	
 ***************************************************************************/

#ifndef _CD_WORD_H
#define _CD_WORD_H
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */
#include "cdda_ioc.h"
#include "cdda_ext.h"

/****************************************************************************
 *	TrackWord: 󥰥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *		struct cd_time wordTime;			λɽϻ
 *		char *word;							λʣʬ
 *		struct _TrackWord *next_ptr;		ؤΥ
 *	
 *		󥯡ݥ󥿤ϡNULL ΤȤü򼨤
 *	
 *		Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *		ʲ˥ǡ줿Υǡ¤򼨤
 *		
 *		λƬ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		λ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		NULLݥ
 *		
 *	
 ***************************************************************************/
typedef struct _TrackWord {
	struct cd_time wordTime;		/* λɽ򳫻Ϥãıջ */
	char *word;						/* λ */
	struct _TrackWord *next_ptr;	/* ؤΥ */
} TrackWord;

/****************************************************************************
 *	DiscWord : λǡ¤
 *	С
 *		int lines;				λԿ
 *		TrackWord **trackWords;	ȥåβλǡؤΥݥؤ
 *	
 *		NULL ΤȤϡλǡ¸ߤʤȤ򼨤
 *		
 *	λǡ¤
 *	
 *	λԿĥǥǲʬ뤫򼨤
 *	
 *	ǥΥȥåĲλΥݥ
 *	
 *	λؤΥݥ󥿤Υݥ󥿨ĥȥåʬΥݥؤ
 *	
 *	
 *	
 *	
 *	λؤΥݥ󥿣λλĢλNULLݥ
 *	
 *	λؤΥݥ󥿣 NULL ݥ
 *	
 *	ġ
 *	
 *	λؤΥݥ󥿣بλλĢλNULLݥ
 *	
 *	λǡι¤Ρ
 *		
 *	­
 *		λؤΥݥ󥿣ӣؤϡλǡ¸ߤȥå򼨤
 *		λؤΥݥ󥿣ϡλǡ¸ߤʤȥå򼨤
 *		λǡʬϡTrackWord;Υǡ¤Ǥ뤬ǤϾά
 *		Ƥ롣
 *		
 ***************************************************************************/
typedef struct _DiscWord {
	int lines;				/* λԿ */
	int tracks;				/* ȥå */
	TrackWord **trackWords;	/* ȥåβλؤΥݥؤ */
} DiscWord;

typedef enum _WordsError {
	WordsErrorNone, WordsIllegalOrder, WordsTooLong, WordsErrorNum
} WordsError;

extern WordsError LyricsError;

/*********************
 *	ץȥ
 *********************/
TrackWord *trackWordAlloc(void);
void wordRelease(TrackWord *release_ptr);
void wordLinkRelease(TrackWord *lyric);
int wordCount(TrackWord *lyric);
int discWordCount(DiscWord *lyrics);
DiscWord *DiscWordAlloc(int tracks);
void DiscWordRelease(DiscWord *lyrics);
int wordsLength(TrackWord *lyric);
int getWordTracks(FILE *stream);
void getWord(DiscWord *discWords, FILE *stream);
void putWord(DiscWord *discWords, FILE *stream);
char **makeWords(TrackWord *lyric);
TrackWord *wordCountSearch(TrackWord *lyric, int lines);
TrackWord **wordsptrCountSearch(TrackWord **lyric_ptr_ptr, int lines);
int wordsTime(struct cd_time *time);
int wordsTimeTest(TrackWord *lyric, 
						struct cd_time *start, struct cd_time *end);
int lyricCmp(TrackWord *lyric1, TrackWord *lyric2);
int wordsTimeSearch(TrackWord *lyric, struct cd_time *wordTime_ptr);
int stearchChar(const unsigned char *string, int c);
int remakeEditWords(TrackWord **lyric_ptr_ptr, const unsigned char *string);
unsigned const char *wordStringOut(const void *stringInfo);
const void *wordNextString(const void *stringInfo);
#endif /*_CD_WORD_H*/

